// Contact person :	KiP

#ifndef VBELEM_BUILTIN_PROPERTYIDS_HPP
#define VBELEM_BUILTIN_PROPERTYIDS_HPP

#pragma once

// === Includes ========================================================================================================

// from GSRoot
#include "GSGuid.hpp"

// from BuiltInProperties
#include "BuiltInPropertiesExport.hpp"

// =====================================================================================================================

namespace Property {

// =====================================================================================================================
//													Field Properties
// =====================================================================================================================

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		General3DLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		General3DPerimeterPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralAbsoluteTopLinkStoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralArchicadIFCIdPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralBottomElevationToFirstReferenceLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralBottomElevationToHomeStoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralBottomElevationToProjectZeroPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralBottomElevationToSeaLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralBottomElevationToSecondReferenceLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralBuildingMaterialPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralBuildingMaterialsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralBuildMatOrCompositOrProfileOrFillIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralCollidingZonesNamesPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralComplexProfilePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralCompositeStructurePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralConditionalVolumePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralCoverFillPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralElementClassificationPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralElementIDPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralElevationToFirstReferenceLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralElevationToProjectZeroPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralElevationToSeaLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralElevationToSecondReferenceLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralElevationToStoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralExternalIFCIdPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralFillTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralFloorPlanHolesPerimeterPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralFloorPlanPerimeterPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralFromZoneNumberPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralFromZonePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralGrossVolumePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralHeightPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralOpeningNumberPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralHoles3DPerimeterPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralHomeOffsetPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralHomeStoryDisplayNumberPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralHomeStoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralHotlinkAndElementIDPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralHotlinkMasterIDPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralInsulationSkinThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralLastIssueDatePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralLastIssueIDPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralLastIssueNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralLayerIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralLibraryPartNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralLinkedChangesPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralListingLabelTextPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralLockedPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralNetVolumePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralOpeningIDsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralOwnerIDPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralPropertyObjectNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralRelatedZoneNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralRelatedZoneNumberPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralRelativeTopLinkStoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralSlantAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralStructureTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralSurfacesPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralTopElevationToFirstReferenceLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralTopElevationToHomeStoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralTopElevationToProjectZeroPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralTopElevationToSeaLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralTopElevationToSecondReferenceLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralTopLinkStoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralTopOffsetPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralToZoneNumberPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralToZonePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralUniqueIDPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralCrossSectionHeightAtEndPerpendicularPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralCrossSectionHeightAtBeginPerpendicularPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralCrossSectionWidthAtEndPerpendicularPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralCrossSectionWidthAtBeginPerpendicularPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralCrossSectionHeightAtEndCutPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralCrossSectionHeightAtBeginCutPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralCrossSectionWidthAtEndCutPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralCrossSectionWidthAtBeginCutPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralCrossSectionAreaAtBeginCutPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralCrossSectionAreaAtEndCutPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeneralSegmentCountPropertyId;


BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamBottomMaterialIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamBottomSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamBuildMatOrProfileIndexPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamConditionalVolumePropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamCrossSectionPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamEndMaterialIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamEndSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamHeightPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamHoleHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamHoleLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamHoleNumberPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamHoleWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamHolesEdgeSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamHolesSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamHolesVolumePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamLeftMaterialPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamLeftSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamLengthLeftPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamLengthRightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamOffsetPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamRightMaterialPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamRightSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamSlantAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamTopMaterialIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamVolumePropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamWidthPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamExtrusionMaterialPropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamSegmentBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamSegmentLeftMaterialIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamSegmentTopMaterialIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamSegmentExtrusionMaterialIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamSegmentRightMaterialIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamSegmentBottomMaterialIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamSegmentEndsMaterialIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamSegmentCrossSectionPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamSegmentEndSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamSegmentLeftSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamSegmentRightSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamSegmentBottomSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamSegmentTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BeamSegmentStructureTypePropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilBottomElevationPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilBottomSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilBottomSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilBuildMatOrCompositeIndexPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilConditionalBottomSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilConditionalTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilConditionalVolumePropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilCoverFillPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilEdgeSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilEdgeSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilGrossBottomSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilGrossBottomSurfaceAreaWithHolesPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilGrossEdgeSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilGrossEdgeSurfaceAreaWithHolesPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilGrossTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilGrossTopSurfaceAreaWithHolesPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilGrossVolumePropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilGrossVolumeWithHolesPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilHolesPerimeterPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilHolesSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilPerimeterPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilReferencePlaneLocationPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilThicknessPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilTopElevationPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilTopSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CeilVolumePropertyId_Obsolete;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnAreaPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnBuildMatOrProfileIndexPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnCoreDepthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnCoreVolumePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnCoreWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnCrossSectionPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnGrossCoreSideSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnGrossCoreTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnGrossCoreBottomSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnGrossCoreVolumePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnGrossVeneerSideSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnGrossVeneerTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnGrossVeneerBottomSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnGrossVeneerVolumePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnGrossVolumePropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnHeightPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnHomeOffsetPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnMaximumHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnMinimumHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnNetCoreBottomSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnNetCoreSideSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnNetCoreTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnNetVeneerBottomSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnNetVeneerSideSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnNetVeneerTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnPerimeterOfBasePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSlantAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnTopLinkStoryPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnTopOffsetPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnVeneerBuildMatIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnVeneerTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnVeneerVolumePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnVolumePropertyId_Obsolete;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSideSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnEndSurfacePropertyId;


BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentExtrusionMaterialIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentEndsMaterialIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentCrossSectionPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentVeneerBuildMatIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentNetVeneerSideSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentVeneerTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentNetVeneerBottomSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentNetVeneerTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentGrossCoreSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentGrossCoreTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentGrossCoreBottomSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentGrossVeneerSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentGrossVeneerTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentGrossVeneerBottomSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentPerimeterPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentGrossCoreVolumePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentGrossVeneerVolumePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentNetCoreBottomSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentNetCoreSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentNetCoreTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentCoreVolumePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentNetVeneerVolumePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentCoreDepthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ColumnSegmentCoreWidthPropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallBoundarySurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallContourSurfaceAreaPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallHeightPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallLengthOfContourFramesPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallLengthOfCustomFramesPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallLengthOfFramesPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallLengthOfMainAxisFramesPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallLengthOfSecAxisFramesPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallNumPanelsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPatternAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallSlantAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallSurfAreaOfPanelsEPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallSurfAreaOfPanelsNEPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallSurfAreaOfPanelsNPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallSurfAreaOfPanelsNWPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallSurfAreaOfPanelsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallSurfAreaOfPanelsSEPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallSurfAreaOfPanelsSPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallSurfAreaOfPanelsSWPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallSurfAreaOfPanelsWPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallThicknessPropertyId_Obsolete;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallAccessoryBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallAccessoryClassPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallAccessoryHeightPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallAccessoryLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallAccessoryTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallAccessoryWidthPropertyId_Obsolete;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallFrameBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallFrameBuildMatIndexPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallFrameClassPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallFrameDepthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallFrameLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallFrameLocationPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallFrameSlantAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallFrameSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallFrameTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallFrameWidthPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallSubelementCurtainWallIdPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallFrameProfileHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallFrameProfileWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallFrameProfileWxHPropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallJunctionBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallJunctionClassPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallJunctionTypePropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelAbbreviationOfOrientationPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelAngleFromNorthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelBuildMatIndexPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelClassPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelEdgeSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelFromZoneNumberPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelFromZonePropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelFunctionPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelAreaWithClampsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelHeightPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelInsideSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelNominalHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelAreaWithoutClampsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelNominalWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelOrientationPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelOutsideSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelPerimeterPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelSlantAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelThicknessPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelToZoneNumberPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelToZonePropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		CurtainWallPanelWidthPropertyId_Obsolete;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FreeShapeBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FreeShapeBuildMatIndexPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FreeShapeCastShadowPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FreeShapeFloorPlanAreaByStoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FreeShapePerimeterPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FreeShapeReceiveShadowPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FreeShapeSurfaceAreaPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FreeShapeSurfaceMaterialPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FreeShapeVolumeByStoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FreeShapeVolumePropertyId_Obsolete;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		HatchBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		HatchBuildMatOrFillIndexPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		HatchFillCategoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		HatchFillTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		HatchHolePerimeterPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		HatchHoleSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		HatchImageNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		HatchPerimeterPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		HatchSurfaceAreaPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		HatchTransparencyPropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		LampBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		LampColorBluePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		LampColorGreenPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		LampColorRedPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		LampIntensityPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		LampTurnedOnPropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		MeshBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		MeshBottomMatIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		MeshBottomSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		MeshBuildMatIndexPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		MeshCoverFillIndexPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		MeshHolePerimeterPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		MeshHoleSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		MeshPerimeterPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		MeshSideMatIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		MeshSideSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		MeshSkirtLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		MeshTopMatIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		MeshTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		MeshTypeIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		MeshVolumePropertyId_Obsolete;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ObjectLampBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ObjectLampHeightPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ObjectLampLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ObjectLampRotationAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ObjectLampSurfaceAreaPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ObjectLampSurfaceMaterialPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ObjectLampVolumePropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ObjectLampWidthPropertyId_Obsolate;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningFillerBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningFillerHeightPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningFillerLibraryPartNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningFillerSideFillIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningFillerWidthPropertyId_Obsolete;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningCenterHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningCenterHeightToProjectZeroPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningCenterHeightToWallBottomPropertyId;	
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningCenterHeightToWallTopPropertyId;		
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningCutSymbolNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningHeaderHeightToHomeStoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningHeaderHeightToProjectZeroPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningHeaderHeightToWallBottomPropertyId;	
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningHeaderHeightToWallTopPropertyId;		
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningIdOfLinkedElementsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningLimitsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningNumberOfLinkedElementsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningOrientationPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningShapePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningSillHeightToHomeStoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningSillHeightToProjectZeroPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningSillHeightToWallBottomPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningSillHeightToWallTopPropertyId;	
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningTotalThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		OpeningUncutSymbolNamePropertyId;


BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingNumberOfBalustersPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingNumberOfHandrailsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingNumberOfInnerPostsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingNumberOfPanelsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingNumberOfPostsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingNumberOfRailsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingNumberOfToprailsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingReferenceLine2DLengthPropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingSegmentBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingSegmentNumberOfBalustersPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingSegmentNumberOfHandrailsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingSegmentNumberOfInnerPostsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingSegmentNumberOfPanelsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingSegmentNumberOfRailsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingSegmentNumberOfToprailsPropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingMemberBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingMemberMemberIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RailingMemberSegmentIndexPropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RiserBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RiserFlightIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RiserFrontSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RiserSegmentTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RiserSlantAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RiserStepIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RiserThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RiserTotalSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RiserWidthPropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofBottomSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofBuildMatOrCompositeIndexPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofConditionalBottomSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofConditionalTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofConditionalVolumePropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofCoverFillPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofDomeConnectionLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofEavesLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofEdgeSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofEndWallConnectionLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofGablesLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofGeometryMethodPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofGrossBottomSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofGrossEdgeSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofGrossTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofGrossVolumePropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofHipsLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofHolesPerimeterPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofHolesSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofHollowConnectionLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofInsulationSkinThicknessPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofNetBottomSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofNetEdgeSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofNetTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofNumberOfHolesPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofNumberOfSkylightsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofOpeningsSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofPeaksLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofPerimeterPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofPitchPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofRidgesLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofRoofLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofSideWallConnectionLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofTopSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofTrimmingBodyPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofValleysLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofVerticalThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoofVolumePropertyId_Obsolete;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomAreaReducementPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomCalculatedAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomCoverFillPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomDoorsSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomDoorsWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomExtractedColumnAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomExtractedFillAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomExtractedLowAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomExtractedWallAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomFloorThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomHeightPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomHolesPerimeterPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomHomeOffsetPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomMeasuredAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomNetAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomNetPerimeterPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomNetVolumePropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomNumberOfBeamsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomNumberOfColumnsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomNumberOfDoorsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomNumberOfLampsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomNumberOfObjectsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomNumberOfTheConcaveCornersPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomNumberOfTheCornersPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomNumberOfWallPartsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomNumberOfWindowsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomPerimeterPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomReducedAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomRelatedElements3DPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomTopLinkStoryPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomTopOffsetPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomTotalExtractedAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomUniformSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomWallInsetBackSideSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomWallInsetSideSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomWallInsetTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomWallsPerimeterPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomWallsSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomWindowsSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomWindowsWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomZoneCategoryCodePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomZoneCategoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomZoneNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RoomZoneNumberPropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellBuildMatOrCompositeIndexPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellConditionalSurfaceAreaOfOppositeSidePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellConditionalSurfaceAreaOfReferenceSidePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellConditionalVolumePropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellDistortionAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellDomeConnectionLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellEavesLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellEdgeSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellEndAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellEndWallConnectionLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellGablesLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellGeometryMethodPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellGrossSurfaceAreaOfEdgesPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellGrossSurfaceAreaOfOppositeSidePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellGrossSurfaceAreaOfReferenceSidePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellGrossVolumePropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellHipsLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellHolesPerimeterPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellHolesSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellHollowConnectionLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellInsulationSkinThicknessPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellNetSurfaceAreaOfEdgesPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellNetSurfaceAreaOfOppositeSidePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellNetSurfaceAreaOfReferenceSidePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellNetVolumePropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellNumberOfHolesPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellNumberOfSkylightsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellOpeningsSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellPeaksLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellPerimeterPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellRevolutionAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellRidgesLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellSideWallConnectionLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellStartAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellSurfaceOfShellOnOppositeSidePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellSurfaceOfShellOnReferenceSidePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellThicknessPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellTrimmingBodyPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ShellValleysLengthPropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightAcousticRatingPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightCurbHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightFireRatingPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightFromZoneNumberPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightFromZonePropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightHeaderHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightHostIdPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightMarkerTextPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightOpeningAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightHeightPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightOpeningHeightPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightOpeningVolumePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightOpeningWHSizePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightOpeningDimensionsPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightUnitDimensionsPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightOpeningWHTSizePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightWidthPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightOpeningWidthPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightRoofConstrainPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightSillHeaderValuePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightSillHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightToZoneNumberPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightToZonePropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SkylightVerticalAnchorPropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairDefaultGoingPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairDefaultRiserHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairDefaultRiserSlantAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairFlightWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairFrontSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairGradientPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMaximumGoingByRulePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMaximumRiserHeightByRulePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMinHeadroomHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMinimumGoingByRulePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMinimumRiserHeightByRulePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairTotalRiserNumPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairTotalTreadNumPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairWalkingLineLengthPropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairStructureBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairStructureConstructionTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairStructureLeftDrainLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairStructureRightDrainLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairStructureDrainLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairStructureDrainPositionPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairStructurePositionPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairStructureProfileHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairStructureProfileWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairStructureProfileWxHPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairStructureSecondaryThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairStructureShapeTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairStructureStairStructureFlightIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairStructureThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairStructure3DHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairStructureStairStructureLandingIndexPropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMemberBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMemberFligthIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMemberFronSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMemberSegmentTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMemberStepIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMemberTotalSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMemberBackWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMemberFrontWitdhPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMemberTreadTopSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMemberTreadFlightLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMemberTreadGoingPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMemberTreadNosingPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMemberRiser3DHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		StairMemberLandingIndexPropertyId;


BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		TreadBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		TreadBackWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		TreadDepthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		TreadFlightIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		TreadFrontSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		TreadFrontWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		TreadSegmentTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		TreadStepIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		TreadTotalSurfaceAreaPropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallAirThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallAnalyticalHoleInsideSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallAnalyticalHoleOutsideSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallAnalyticalHoleVolumePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallAreaPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallAverageLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallBuildMatOrCompositeOrProfileIndexPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallCenterLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallColumnNumberPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallColumnVolumeNotCalculatedPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallConditionalInsideLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallConditionalInsideSkinVolumePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallConditionalInsideSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallConditionalOutsideLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallConditionalOutsideSkinVolumePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallConditionalOutsideSurfacePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallConditionalVolumePropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallDoorNumberPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallDoorSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallDoorWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallEdgeSurfaceIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallEmptyHolesSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallEndThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallGeometryMethodPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallGrossInsideSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallGrossOutsideSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallGrossVolumePropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallHeightPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallHoleNumberPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallHomeOffsetPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallInsideLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallInsideMaximumHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallInsideMinimumHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallInsideSkinVolumePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallInsideSlantAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallInsideSurfaceIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallInsideThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallInsulationThicknessPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallMaximumHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallMinimumHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallNetEdgeSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallNetInsideSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallNetOutsideSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallOutsideLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallOutsideMaximumHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallOutsideMinimumHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallOutsideSkinVolumePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallOutsideSlantAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallOutsideSurfaceIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallOutsideThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallPerimeterPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallReferenceLineLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallReferenceLineLocationPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallSlantTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallThicknessPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallTopLinkStoryPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallTopOffsetPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallVolumePropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallWidthPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallWindowNumberPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallWindowSurfaceAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WallWindowWidthPropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorAcousticRatingBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorEgressDimensionBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorFireRatingBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorFromZoneBuiltInPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorFromZoneNumberBuiltInPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorGrossSurfaceBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorGrossVolumeBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorHeadHeightFromAnchorBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorHeightBuiltInPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorLeafDimensionBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorMarkerTextBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorNominalOppositeRevealSideHeightBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorNominalOppositeRevealSideSurfaceBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorNominalOppositeRevealSideWidthBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorNominalRevealSideHeightBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorNominalRevealSideSurfaceBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorNominalRevealSideWidthBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorOpeningVolumeBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorOppositeRevealSideHeadHeightBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorOppositeRevealSideHeightBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorOppositeRevealSideSillHeightBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorOppositeRevealSideSurfaceBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorOppositeRevealSideWidthBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorOrientationBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorRevealDimensionBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorRevealSideHeadHeightBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorRevealSideHeightBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorRevealSideSillHeightBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorRevealSideSurfaceBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorRevealSideWidthBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorSillHeaderValueFromAnchorBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorSillHeightFromAnchorBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorSurfaceBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorThicknessBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorToZoneBuiltInPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorToZoneNumberBuiltInPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorUnitDimensionBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorVolumeBuiltInPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorWHSizeBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorWHTSizeBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorWallFillBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorWallHoleDimensionBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorWallThicknessBuiltInPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		WindowDoorWidthBuiltInPropertyId_Obsolete;

// =====================================================================================================================
//													Criteria Properties
// =====================================================================================================================

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		MainBuiltInPropertyGroupId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionAccessoryClassPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionAccessoryTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionColumnVennerTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionColumnSegmentVeneerTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionCompositeNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionCompositePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionComponentTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionCurtainWallBoundaryFramePlacementPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionFrameClassPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionFrameTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionFrameIntersectionLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionFreeShapeSolidityPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionJunctionClassPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionJunctionTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionMeshTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionPanelClassPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionPanelFunctionPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionPanelTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionProfileNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionProfilePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionRoofCroppedPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionRoofEavesOverhangTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionRoofLevelNumberPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionRoofTrimmingBodyPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionSchemeCategoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionShellTrimmingBodyPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionStructureTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionPanelFunctionPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ConstructionWallSlantTypePropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_BuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_2DOutlinePen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_3DOutlinePen_PropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_AngDimArrowPen_PropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_AngDimLeaderLinePen_PropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_AngDimLeaderLineType_ProrpertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_BasicElementBuildingMaterialFill_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_AxisLinePen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_AxisLineType_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_BuildingMaterialCutFillIndex_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_ComponentCutFillBackgroundPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_ComponentCutFillForegroundPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_ComponentCutFillOutlinePen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CurtainWallFrameBuildMatFillPen_PropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CurtainWallFrameCutLinePen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_ColumnCoreFillPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_ColumnVeneerCutFill_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CoreBackgroundPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CoreFill_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CoverFillBackroundPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CoverFillPatternPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CoverFillType_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CurtainWallFrameCutLineType_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CurtainWallFrameFillBackgroundPen_PropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CurtainWallOverheadLineType_PropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CurtainWallOverheadLinePen_PropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CurtainWallPanelFillBackgroundPen_PropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CurtainWallPanelCutLinePen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CurtainWallPanelCutLineType_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CurtainWallPanelBuildingMaterialFillPen_PropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CurtainWallUncutLinePen_PropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CurtainWallUncutLineType_PropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CutFill_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CutFillBackgroundPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CutFillOutlinePen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CutLinePen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_CutLineType_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_DimArrowPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_DimLeaderLinePen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_DimLeaderLineType_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_FillBackgroundPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_FillForegroundPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_FillIndexList_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_FillOutlinePen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_FontIdList_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_FontSizeList_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_FontStyleList_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_GeneralArrowPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_GeneralOverheadLineType_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_GeneralOverheadLinePen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_GeneralLeaderLinPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_GeneralLineType_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_HatchFillCategory_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_LabelArrowPen_PropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_LabelLeaderLinePen_PropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_LeadingList_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_LevDimMarkerPen_PropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_LineBaseArrowPen_PropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_MarkerPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_MeshRidgePen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_PenIndexList_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_PenOverride_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_ShellBaseOverheadLineType_PropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_ShellBaseOverheadLinePen_PropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_SurfaceVectorialHatching_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_TextAlignmentList_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_TextPenIndexList_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_OutlinePen_PropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_UncutLinePen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_UncutLinePen_PropertyId_Obosolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_UncutLineType_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_VeneerBackgroundPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_VeneerForegroundPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_HiddenContourLineType_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		FloorPlanAndSection_HiddenContourLinePen_PropertyId;


BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryAccessoryHeightPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryAccessoryLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryAccessoryWidthPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCeilAndShellBaseThicknessPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryBeamCrossSectionPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryBeamSegmentCrossSectionPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryBeamSlantAnglePropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryColumnCoreDepthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryColumnCoreDiamaterPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryColumnCoreWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryColumnCrossSectionPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryColumnSegmentCrossSectionPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryColumnDiamaterPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryColumnLengthPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryColumnSlantAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryColumnVeneerThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryComponentThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryComponentCrossSectionHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryComponentCrossSectionWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryComponentCrossSectionAreaPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryChangeMarkerMarkerSizePropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCurtainWallFrameSlantAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCurtainWallPanelNominalHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCurtainWallPanelNominalWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCurtainWallPanelOrientationPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCurtainWallPanelThicknessPropertyId_Obsolated;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeonetryCurtainWallPanelOffsetPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCurtainWallPanelWidthPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCurtainWallPanelHeightPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCurtainWallSlantAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCurtainWallThicknessPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryDetailMarkerSizePropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryFrameDepthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryFrameDepthFromCenterlinePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryFramePanelSlotDepthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryFramePanelSlotWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryFrameWidthPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryGeneral3DLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryGeneralEdgeDefaultAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryGeneralHeightPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryGeneralHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryGeneralLengthPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryGeneralMarkerSizePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryGeneralThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryGeneralWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryInvertedHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryStairInvalidHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryGeneralWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryObjectHeightPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryObjectLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryObjectWidthPropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryOpeningShapePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryOpeningOrientationPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryOpeningLimitsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryOpeningTotalThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryMeshSkirtLevelProperyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryProfileHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryProfileWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryRiserSlantAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryRiserWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryRiser3DHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryRoofEavesOverhangPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryRoofEdgeAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryRoofEdgeCustomAnglePropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryRoofGeometryMethodPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryRoofPitchPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometrySchemePrimaryPatternPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometrySchemeSecondaryPatternPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometrySchemeSecondaryGridAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryShellGeometryMethodPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryShellBaseEdgeAnglePropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometrySlabEdgeAngleTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometrySlabEdgeCustomAnglePropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryShellInclineAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryStairDefaultWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryStairGradientPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryStairMinHeadroomHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryStairStructure3DHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryStairSubElementFlightIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryStairSubElementLandingIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryTreadBackWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryTreadFlightLengthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryTreadFrontWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryTreadGoingPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryTreadNosingPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryTreadTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryWallGeometryMethodPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryWallInsideSlantAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryWallOpeningRevealDepthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryWallOpeningJambWidthOnePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryWallOpeningJambWidthTwoPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryWallOutsideSlantAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryWorksheetMarkerSizePropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryStairModelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCrossSectionHeightAtEndPerpendicularPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCrossSectionHeightAtBeginPerpendicularPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCrossSectionWidthAtEndPerpendicularPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCrossSectionWidthAtBeginPerpendicularPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCrossSectionHeightAtEndCutPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCrossSectionHeightAtBeginCutPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCrossSectionWidthAtEndCutPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCrossSectionWidthAtBeginCutPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCrossSectionAreaAtBeginCutPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryCrossSectionAreaAtEndCutPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryColumnSegmentVeneerThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryColumnSegmentCoreWidthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometryColumnSegmentCoreDepthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		GeometrySegmentedAssemblySegmentCountPropertyId;


BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesChangeMarkesIsLinkedPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesCurtainWallOwnerIdPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesDrawingNameProperyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesElementIDPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesOpeningNumberPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesHotlinkAndElementIDPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesHotlinkMasterIDPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesHotlinkSourceIDPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesIsLegacyStairPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesLabelMarkerNamePropertyId_Obosolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesLabelContentTypePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesLampOnOffStatePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesLibraryPartNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesListingLabelTextPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesLockedPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesMEPSystemPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesMarkerNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesOpeningCutSymbolNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesOpeningIDsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesOpeningUncutSymbolNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesParentIdPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesPropertyObjectNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesRelatedZoneCategoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesRelatedZoneNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesRelatedZoneNumberPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesSubtypeNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesSkylightHostRoofShellIdPropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesTreadStepIndexPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesUniqueIDPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesZoneCategoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesZoneNumberStrPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IdAndCategoriesZoneStampNamePropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ModelViewBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ModelViewAnnotationStatePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ModelViewLayerCombinationPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ModelViewLibraryPartMissingPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ModelViewLayerNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ModelViewLayerPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		ModelViewMissingAttributePropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningAbsoluteTopLinkStoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningBottomElevationToFirstReferenceLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningBottomElevationToHomeStoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningBottomElevationToProjectZeroPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningBottomElevationToSeaLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningBottomElevationToSecondReferenceLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningCurtainWallFrameLocationPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningCurtainWallPanelAbbreviationOfOrientationPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningCurtainWallPanelAngleFromNorthPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningCurtainWallPanelSlantAnglePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningElevationToCurrentStoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningElevationToProjectZeroPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningElevationToFirstReferenceLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningElevationToSecondReferenceLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningElevationToSeaLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningHeadHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningHomeOffsetPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningHomeStoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningOpeningCenterHeightToHomeFloorPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningOpeningCenterHeightToProjectZeroPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningOpeningCenterHeightToWallBottomPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningOpeningCenterHeightToWallTopPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningOpeningHeaderHeightToProjectZeroPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningOpeningHeaderHeightToWallBottomPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningOpeningHeaderHeightToWallTopPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningOpeningSillHeightToProjectZeroPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningOpeningSillHeightToWallBottomPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningOpeningSillHeightToWallTopPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningOpeningSubfloorThicknessPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningRelativeTopLinkStoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningSchemeGridOriginPositionPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningSillHeightPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningSlabReferencePlaneLocationPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningTopElevationToFirstReferenceLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningTopElevationToHomeStoryPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningTopElevationToProjectZeroPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningTopElevationToSeaLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningTopElevationToSecondReferenceLevelPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningTopOffsetPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningWallReferenceLineLocationPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		PositioningWallOpeningOrientationPropertyId;


BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RulesAndStandardsBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RulesAndStandardsStairMaximumRiserHeightByRulePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RulesAndStandardsStairMaximumTreadDepthByRulePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RulesAndStandardsStairMinimumRiserHeightByRulePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RulesAndStandardsStairMinimumTreadDepthByRulePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RulesAndStandardsStairNumOfRisersPerFlightsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RulesAndStandardsStairNumOfTreadsPerFlightsPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RulesAndStandardsStairTotalRiserNumPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RulesAndStandardsStairTotalTreadNumPropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_BuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_BeamEdgeSideSurfaceIndex_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_BeamLeftSideSurfaceIndex_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_BeamRightSideSurfaceIndex_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_BuildingMaterialIdListFromElem_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_BuildingMaterialIdList_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_BuildingMaterialListFromElem_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_BuildingMaterialList_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_BuildingMaterialNameListFromElem_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_BuildingMaterialNameList_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_ColumnCoreBuildingMaterial_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_ColumnVeneerBuildingMaterial_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_ComponentBuildingMaterial_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_ComponentBuildingMaterialID_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_ComponentBuildingMaterialName_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_CurtainWallFrameBuildingMaterial_PropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_CurtainWallPanelBuildingMaterial_PropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_EdgeSurface_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_GeneralTopSurfaceIndex_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_GeneralBottomSurfaceIndex_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_InsideSurface_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_OutsideSurface_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_MeshSideMaterial_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_PanelEdgeSurfaceMaterial_PropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_PanelInsideSurfaceMaterial_PropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_PanelOutsideSurfaceMaterial_PropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_RoofEaveSurface_PropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_ShellEaveSurface_PropertyId_Obsolete;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_SurfaceColor_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_SurfaceDiffersFromBuildingMaterials_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_SurfaceListFromElem_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_SurfaceListOfElement_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_SurfaceListOfComponent_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_SurfaceIndex_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_SurfaceName_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_SurfaceNameListFromElem_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_SurfaceNameList_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_WallOutsideSurface_PropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_WallInsideSuface_PropertyId_Obsolate;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_ExtrusionMaterial_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_ColumnSegmentEndsMaterialIndex_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		SurfaceAndMaterials_ColumnSegmentVeneerBuildingMaterial_PropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IFCBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IFCARCHICADIFCIdPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		IFCExternalIFCIdPropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RevisionBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RevisionChangeMarkerIdPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RevisionChangeMarkerNamePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RevisionLastIssueDatePropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RevisionLastIssueIDPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		RevisionLastIssueNamePropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		LayoutingBuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		LayoutingDrawingColorPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		LayoutingDrawingIDPropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		LayoutingDrawingPenSetProperyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		LayoutingDrawingTitlePropertyId;


// =====================================================================================================================
//											Component and Surface Properties
// =====================================================================================================================

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Component_BuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Component_BuildingMaterialIndex_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Component_CutFillForegroundPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Component_CutFillBackgroundPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Component_CutFillOutlinePen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Component_EmbodiedCarbon_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Component_EmbodiedEnergy_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Component_Mass_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Component_ProjectedArea_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Component_Thickness_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Component_CrossSectionHeight_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Component_CrossSectionWidth_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Component_CrossSectionArea_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Component_Type_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Component_Volume_PropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Surface_BuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Surface_DiffersFromBuildingMaterials_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Surface_MaterialColor_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Surface_MaterialIndex_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Surface_MaterialName_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		Surface_MaterialVectorialHatchingName_PropertyId;

BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BuildingMaterial_BuiltInPropertyGroupId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BuildingMaterial_CutFillIndex_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BuildingMaterial_CutFillForegroundPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BuildingMaterial_CutFillBackgroundPen_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BuildingMaterial_Density_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BuildingMaterial_Description_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BuildingMaterial_HeatCapacity_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BuildingMaterial_ID_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BuildingMaterial_Manufacturer_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BuildingMaterial_Name_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BuildingMaterial_SurfaceIndex_PropertyId;
BUILTIN_PROPERTIES_DLL_EXPORT	extern const GS::Guid		BuildingMaterial_ThermalConductivity_PropertyId;

}

#endif
