#include "FixArray.hpp"
#include "GSPix.h"

namespace DefaultPatternIndices {
enum DefaultPatternIndices : UIndex {
	Black = 0,
	DkGray,
	Gray,
	LtGray,
	White,
	Ugly,
	LtltGray,
	Horiz,
	Vert,
	Horiz2,
	Vert2,
	Curve,
	Perc13,
	Perc43,
	Perc63,
	Perc93
};
}

const GS::FixArray <GSPattern, 16> DefaultPatterns = {
	GSPattern ( 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF ), /* qd.black */
	GSPattern ( 0x77, 0xDD, 0x77, 0xDD, 0x77, 0xDD, 0x77, 0xDD ), /* qd.dkGray */
	GSPattern ( 0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55 ), /* qd.gray */
	GSPattern ( 0x88, 0x22, 0x88, 0x22, 0x88, 0x22, 0x88, 0x22 ), /* qd.ltGray */
	GSPattern ( 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 ), /* qd.white */
	GSPattern ( 0xB1, 0x30, 0x03, 0x1B, 0xD8, 0xC0, 0x0C, 0x8D ), /* ugly */
	GSPattern ( 0x80, 0x10, 0x02, 0x20, 0x01, 0x08, 0x40, 0x04 ), /* ltltGray */
	GSPattern ( 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88 ), /* horiz */		/* was 5. now  7. */
	GSPattern ( 0xFF, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00 ), /* vert */		/* was 6. now  8. */
	GSPattern ( 0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77 ), /* horiz */		/* was 7. now  9. */
	GSPattern ( 0x00, 0xFF, 0xFF, 0xFF, 0x00, 0xFF, 0xFF, 0xFF ), /* vert */		/* was 8. now 10. */
	GSPattern ( 0x55, 0xBB, 0x55, 0xEE, 0x55, 0xBB, 0x55, 0xEE ), /* curve */		/* was 9. now 11. */
	GSPattern ( 0x11, 0x00, 0x44, 0x00, 0x11, 0x00, 0x44, 0x00 ), /* 13% (#12)*/
	GSPattern ( 0x88, 0x55, 0x11, 0xAA, 0x88, 0x55, 0x11, 0xAA ), /* 43% (#13)*/
	GSPattern ( 0x77, 0xAA, 0xEE, 0x55, 0x77, 0xAA, 0xEE, 0x55 ), /* 63% (#14)*/
	GSPattern ( 0xEE, 0xFF, 0xBB, 0xFF, 0xEE, 0xFF, 0xBB, 0xFF )  /* 93% (#15)*/
};