// *****************************************************************************
// Basic Geometric entities in C. (Point2D, Point3D, Circle, GenArc, Box, etc.)
// Geometry, platform-independent
//
// Namespaces:        Contact person:
//     Geometry          RJ, FGY
//
// *****************************************************************************

#if !defined (BASICGEOMETRY_H)
#define BASICGEOMETRY_H

#pragma once

#include "RealNumber.h"

#include "AngleData.h"

#include "Point2DData.h"
#include "Point3DData.h"
#include "TM.h"
#include "TMB.h"

#include "Sector2DData.h"
#include "Sector3DData.h"

#include "Intersection2D.hpp"

#include "Box2DData.h"
#include "Box3DData.h"

#include "Plane.hpp"
#include "Plane3DData.h"

#include "Circle2DData.h"
#include "Sphere3DData.h"

#include "GenArc2DData.h"

#include "Ellipse2DData.h"

#include "GeometryMain.h"

#endif
